;+=========================================================================-;
; TG16 Pad reader									      ;
;+=========================================================================-;

;(c) AFD 1990

;+=========================================================================-;
; Toggle port O CLR line thru LO HI LO to clear any jive				;
; When CLR is LO , then data is available from padport K				;
; When CLR is HI , data is available from turboexpress com link			;
;+=========================================================================-;


;Joyena gives active pads

get_pads:	lda #%00000001		;CLR lo SEL hi    (Write cycle)
	sta joyio
	lda #%00000011		;CLR hi SEL hi
	sta joyio

padloop1:	lda #1			;CLR lo SEL hi
	sta joyio
	pha
	pla				;Wait for port
	nop
	lda joy
	sta old_joy			;For debouncing
	lda joyio
	asl a
	asl a	
	asl a
	asl a
	sta joy
	stz joyio			;All lo
	pha
	pla
	nop
	lda joyio
	and #$0f
	ora joy		   	;Mask in joy bits
	eor #$ff
	sta joy			;And stash
	eor old_joy			;Debounce
	and joy
	sta joy_trg			;Trigger status

padloop2:	lda joy_trg
	cmp #sel
	bne no_pad
	lda joy
	cmp #sel+run
	bne no_pad
	sei
	lda #$ff
	tam0
	lda #$f8
	tam1
	lda #$90
	tam2
	lda #$0a
	tam3
	lda #$01
	tam4
	inc a
	tam5
	inc a
	tam6
	cla
	tam7
	jmp restart

no_pad:	rts

pad_table:
	db 1,2,4,8,16

	
	
